# frozen_string_literal: true

require 'wag/version'

module WAG
  class Error < StandardError; end
  # Your code goes here...

  require 'wag/encodable'
  require 'wag/inflector'
  require 'wag/instructable'

  require 'wag/data'
  require 'wag/element'
  require 'wag/export'
  require 'wag/f32_instructions'
  require 'wag/f64_instructions'
  require 'wag/function'
  require 'wag/function_type'
  require 'wag/global_instructions'
  require 'wag/global'
  require 'wag/i32_instructions'
  require 'wag/i64_instructions'
  require 'wag/import'
  require 'wag/indices'
  require 'wag/instruction'
  require 'wag/label'
  require 'wag/local_instructions'
  require 'wag/local'
  require 'wag/memory_instructions'
  require 'wag/memory'
  require 'wag/module'
  require 'wag/param'
  require 'wag/result'
  require 'wag/table'
  require 'wag/then'
  require 'wag/type'

  require 'wag/wabt'
  require 'wag/wasm'
  require 'wag/wat'
end
