# frozen_string_literal: true

module WAG
  # A simple mixin which formats s-expressions as WAT.
  module Encodable
    def to_wat
      WAG::WAT.new(wat_encode(to_sexpr))
    end

    def to_wasm
      to_wat.to_wasm
    end

    private

    def wat_encode(data)
      return "(#{data.map { |e| wat_encode(e) }.join(' ')})" if data.is_a?(Enumerable)
      return data.inspect if data.is_a?(String)

      data.to_s
    end
  end
end
