# frozen_string_literal: true

module WAG
  class Export
    include WAG::Encodable

    attr_reader :name, :desc

    def initialize(name)
      @name = name
    end

    def func(label, &block)
      @desc = Function.new(label)
      @desc.instance_exec(&block) if block
      @desc
    end

    def global(label, type)
      @desc = Global.new(label, type)
    end

    def memory(number, min = nil, max = nil, &block)
      @desc = Memory.new(number, min, max)
      @desc.instance_exec(&block) if block
      @desc
    end

    def table(number, type = :anyfunc, &block)
      @desc = Table.new(number, type)
      @desc.instance_exec(&block) if block
      @desc
    end

    def to_sexpr
      [:export, name, desc.to_sexpr]
    end
  end
end
