# frozen_string_literal: true

module WAG
  class FunctionType < Function
    def to_sexpr
      [:type].tap do |type|
        type.push(@label.to_sexpr) if @label
        [:func].tap do |func|
          func.concat(@params.map(&:to_sexpr)) unless @params.empty?
          func.push(@result.to_sexpr) if @result
          type.push(func)
        end
      end
    end
  end
end
