# frozen_string_literal: true

module WAG
  class Global
    include WAG::Encodable

    attr_reader :label, :type

    def initialize(label, type)
      @label = WAG::Label.from(label)
      @type = WAG::Type.from(type)
    end

    def to_sexpr
      [:global, label.to_sexpr, type.to_sexpr]
    end
  end
end
