# frozen_string_literal: true

module WAG
  class GlobalInstructions
    def initialize(instructions)
      @instructions = instructions
    end

    %i[get set].each do |instruction_name|
      camelised_name = "Global::#{WAG::Inflector.inflector.camelize(instruction_name)}"
      define_method(instruction_name) do |*args, &block|
        instruction = WAG::Instruction.const_get(camelised_name).new(*args)
        @instructions << instruction
        instruction.instance_exec(&block) if block
        instruction
      end
    end
  end
end
