# frozen_string_literal: true

module WAG
  module Indices
    class Base
      RANGE = [0..0xFFFFFFFF].freeze
      attr_reader :value

      def initialize(value)
        raise "Index 0x#{value.to_s(16)} does not fit in an i32" unless RANGE.cover?(value)

        @value = value
      end
    end
  end
end
