# frozen_string_literal: true

module WAG
  module Instruction
    class Base
      include WAG::Encodable

      def self.instruction(op_code)
        klass = Class.new(self)
        klass.define_method(:op_code) { op_code }
        klass
      end

      def name
        name = WAG::Inflector.inflector.demodulize(self.class.name.to_s)
        WAG::Inflector.inflector.underscore(name).to_sym
      end

      def to_sexpr
        name.to_sym
      end
    end
  end
end
