# frozen_string_literal: true

module WAG
  module Instruction
    class Block < Base.instruction(0x02)
      prepend WAG::Instructable

      def result(*types)
        return @result if types.empty?

        @result = WAG::Result.new(*types)
      end

      def to_sexpr
        return [name, @result.to_sexpr] if @result

        name
      end
    end
  end
end
