# frozen_string_literal: true

module WAG
  module Instruction
    class BrTable < Base.instruction(0x0e)
      prepend WAG::Instructable
      attr_reader :label

      def initialize(*labels)
        @labels = labels.map { |label| WAG::Label.from(label) }
      end

      def to_sexpr
        [name].concat(@labels.map(&:to_sexpr))
      end
    end
  end
end
