# frozen_string_literal: true

module WAG
  module Instruction
    class Call < Base.instruction(0x10)
      prepend WAG::Instructable
      attr_reader :label

      def initialize(label)
        @label = WAG::Label.from(label)
      end

      def to_sexpr
        [:call, label.to_sexpr]
      end
    end
  end
end
