# frozen_string_literal: true

module WAG
  module Instruction
    module F32
      class Const < Base.instruction(0x43)
        prepend WAG::Instructable
        attr_reader :literal

        def initialize(literal)
          @literal = literal.to_f
        end

        def to_sexpr
          [name, @literal]
        end
      end
    end
  end
end
