# frozen_string_literal: true

module WAG
  module Instruction
    module Global
      class Get < Base.instruction(0x23)
        prepend WAG::Instructable
        attr_reader :label

        def initialize(label)
          @label = WAG::Label.from(label)
        end

        def to_sexpr
          [name, label.to_sexpr]
        end
      end
    end
  end
end
