# frozen_string_literal: true

module WAG
  module Instruction
    class If < Base.instruction(0x04)
      prepend WAG::Instructable
      def result(*types)
        @result = WAG::Result.new(*types)
      end

      def then(&block)
        instruction = WAG::Then.new
        instructions << instruction
        instruction.instance_exec(&block) if block
        instruction
      end
      alias then_ then

      def to_sexpr
        return [name, @result.to_sexpr] if @result

        super()
      end
    end
  end
end
