# frozen_string_literal: true

module WAG
  class Label
    include WAG::Encodable

    attr_reader :value

    def initialize(value)
      if value.is_a?(Integer)
        @value = value.to_i
      else
        value = value.to_s
        @value = if value.start_with?('$')
                   value.to_sym
                 else
                   "$#{value}".to_sym
                 end
      end
    end

    def to_sexpr
      value
    end

    def self.from(value)
      return value if value.is_a?(WAG::Label)

      WAG::Label.new(value)
    end
  end
end
