# frozen_string_literal: true

module WAG
  class Memory
    include WAG::Encodable

    attr_reader :label, :number, :min, :max

    def initialize(*args)
      @label = WAG::Label.from(args.shift) if args.first.is_a?(Symbol)

      (@number, @min, @max) = args
    end

    def to_sexpr
      [:memory].tap do |expr|
        expr.push(label.to_sexpr) if label
        expr.push(number)
        if min
          expr.push(min)
          expr.push(max) if max
        end
      end
    end
  end
end
