# frozen_string_literal: true

module WAG
  class Param
    include WAG::Encodable

    attr_reader :type, :label

    def initialize(type, label = nil)
      @type = WAG::Type.from(type)
      @label = WAG::Label.from(label) if label
    end

    def to_sexpr
      return [:param, label.to_sexpr, type.to_sexpr] if label

      [:param, type.to_sexpr]
    end
  end
end
