# frozen_string_literal: true

module WAG
  class Result
    include WAG::Encodable

    attr_reader :types

    def initialize(*types)
      @types = types.map { |t| WAG::Type.from(t) }
    end

    def to_sexpr
      [:result].concat(types.map(&:to_sexpr))
    end
  end
end
