# frozen_string_literal: true

module WAG
  # A container for the WebAssembly binary format.
  class WASM
    def initialize(code)
      @code = code
    end

    def valid?
      WAG::WABT.new.wasm_validate(@code)
    end

    def save(path)
      File.write(path, @code)
    end

    def to_s
      @code
    end
  end
end
